import java.awt.geom.Line2D;
import java.util.ArrayList;

/**
 * Die Klasse Kante repraesentiert Kanten in einem Graphen.
 * Sie stellt auch Methoden zur Verwaltung aller Kanten bereit.
 * 
 * @author claus albowski
 * @version Juni 2015
 */
public class Kante
extends Line2D.Double
implements Comparable  // ermoeglicht das automatische Sortieren mit sort()
{
    // Klassenvariable
    private static ArrayList<Kante> kantenListe = new ArrayList<Kante>();
    private static int x=300;
    private static int y=300;
    // Instanzvariable
    private Knoten p1,p2;
    
    /**
     * Konstruktor fuer Objekte der Klasse Kante
     */
    public Kante(Knoten p1, Knoten p2){
        super(p1, p2);
        this.p1=p1;
        this.p2=p2;
        p1.neueKante(this);
        kantenListe.add(this);
    }
    
    // Klassenmethoden
    public static void setzeDimension(int breite, int hoehe){ x=breite;y=hoehe; }
    public static Kante gibKante(int i){ return kantenListe.get(i); }
    public static int gibAnzahl() { return kantenListe.size(); }
    public static void loescheKanten(){
        while (! kantenListe.isEmpty()) Kante.entferneKante(kantenListe.get(0));
    }
    
    /**
     * entfernt die uebergebene Kante aus der Kantenliste.
     */
    public static void entferneKante(Kante kante){
        kante.gibAusgangsKnoten().entferneKante(kante);
        kantenListe.remove(kante);
    }
    
    // Fuer das Interface  Comparable notwendige Methode:
    public int compareTo(Object k) {
        if (laenge()<((Kante)k).laenge()) return -1;
        else if (laenge()>((Kante)k).laenge()) return 1;
        else return 0;
    }
    
    /**
     * get-Methoden fuer die Knoten
     */
    public Knoten gibAusgangsKnoten() { return p1; }
    public Knoten gibZielKnoten() { return p2; }
    
    /**
     * gibt die Laenge der Kante  zurueck.
     */
    public double laenge(){
        return p1.distance(p2);
    }
}
